#ifndef bqtNewRadixUtilsHH
#define bqtNewRadixUtilsHH

#include "bigint.hh"
#include "templates.hh"

namespace NewRadixEncoder
{
    /* A dummy template parameter is used to make this a weak function
     * in order to avoid having to specify which module to link this in.
     */
    template<int>
    BigInt& GetKeyEnc() { static BigInt key_enc; return key_enc; }
    
    template<typename KeyType, unsigned MaxValue, unsigned MinValue>
    BigInt& Encode(const KeyType*const Key, unsigned KeyLength)
    {
        const unsigned Limit = MaxValue-MinValue;
        
        static BigInt key_enc;
       // BigInt& key_enc = GetKeyEnc<0> ();
        key_enc = 0;
        for(unsigned a=0; a<KeyLength; ++a)
        {
            if(a>0)
            {
                if(Limit==0xFFFFFFFFU)
                    key_enc <<= 32;
                else if(Limit==0xFFFFU)
                    key_enc <<= 16;
                else
                    key_enc *= (Limit+1);
            }
            key_enc += Key[a]-MinValue;
        }
        return key_enc;
    }
};

#endif
