#include "moves.hh"

static const CoordinateType DefaultFacing = -MaxWidth;

struct History
{
    MoveTree Moves;
    unsigned short time;
    
    inline History() { }
    inline History(const History& old)
        : Moves(old.Moves), time(old.time)
    {
    }
    inline History(const History& old, const Move& move)
        : Moves(old.Moves, move), time(old.time)
    {
    }
    
    inline bool Started() const
    {
        return !Moves.empty();
    }
    inline bool WasGrabbing() const
    {
        if(Moves.empty()) return false;
        return Moves.back().type == Move::WalkToPush;
    }
    /*
    int GetLastFacing() const
    {
        if(Moves.empty()) return DefaultFacing;
        return Moves.back().GetFacing();
    }
    */
    
    void Dump(std::ostream& out = std::cout) const;
    const std::string GetJs() const;
} __attribute__((packed));
